## Alpha API Report File for "@fluidframework/shared-object-base"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

// @alpha (undocumented)
export interface IFluidSerializer {
    decode(input: any): any;
    encode(value: any, bind: IFluidHandle): any;
    parse(value: string): any;
    stringify(value: any, bind: IFluidHandle): string;
}

// @alpha
export interface ISharedObject<TEvent extends ISharedObjectEvents = ISharedObjectEvents> extends IChannel, IEventProvider<TEvent> {
    bindToContext(): void;
    getGCData(fullGC?: boolean): IGarbageCollectionData;
}

// @alpha
export interface ISharedObjectEvents extends IErrorEvent {
    // @eventProperty
    (event: "pre-op", listener: (op: ISequencedDocumentMessage, local: boolean, target: IEventThisPlaceHolder) => void): any;
    // @eventProperty
    (event: "op", listener: (op: ISequencedDocumentMessage, local: boolean, target: IEventThisPlaceHolder) => void): any;
}

// @alpha
export interface ISharedObjectKind<TSharedObject> {
    create(runtime: IFluidDataStoreRuntime, id?: string): TSharedObject;
    getFactory(): IChannelFactory<TSharedObject>;
}

// @alpha
export function makeHandlesSerializable(value: any, serializer: IFluidSerializer, bind: IFluidHandle): any;

// @alpha
export function parseHandles(value: any, serializer: IFluidSerializer): any;

// @alpha
export abstract class SharedObject<TEvent extends ISharedObjectEvents = ISharedObjectEvents> extends SharedObjectCore<TEvent> {
    constructor(id: string, runtime: IFluidDataStoreRuntime, attributes: IChannelAttributes, telemetryContextPrefix: string);
    getAttachSummary(fullTree?: boolean, trackState?: boolean, telemetryContext?: ITelemetryContext): ISummaryTreeWithStats;
    getGCData(fullGC?: boolean): IGarbageCollectionData;
    protected processGCDataCore(serializer: IFluidSerializer): void;
    // (undocumented)
    protected get serializer(): IFluidSerializer;
    summarize(fullTree?: boolean, trackState?: boolean, telemetryContext?: ITelemetryContext, incrementalSummaryContext?: IExperimentalIncrementalSummaryContext): Promise<ISummaryTreeWithStats>;
    protected abstract summarizeCore(serializer: IFluidSerializer, telemetryContext?: ITelemetryContext, incrementalSummaryContext?: IExperimentalIncrementalSummaryContext): ISummaryTreeWithStats;
}

// @alpha
export abstract class SharedObjectCore<TEvent extends ISharedObjectEvents = ISharedObjectEvents> extends EventEmitterWithErrorHandling<TEvent> implements ISharedObject<TEvent> {
    constructor(id: string, runtime: IFluidDataStoreRuntime, attributes: IChannelAttributes);
    protected abstract applyStashedOp(content: any): void;
    // (undocumented)
    readonly attributes: IChannelAttributes;
    bindToContext(): void;
    connect(services: IChannelServices): void;
    get connected(): boolean;
    protected get deltaManager(): IDeltaManager<ISequencedDocumentMessage, IDocumentMessage>;
    protected didAttach(): void;
    protected dirty(): void;
    emit(event: EventEmitterEventType, ...args: any[]): boolean;
    abstract getAttachSummary(fullTree?: boolean, trackState?: boolean, telemetryContext?: ITelemetryContext): ISummaryTreeWithStats;
    abstract getGCData(fullGC?: boolean): IGarbageCollectionData;
    readonly handle: IFluidHandleInternal;
    // (undocumented)
    id: string;
    // (undocumented)
    get IFluidLoadable(): this;
    initializeLocal(): void;
    protected initializeLocalCore(): void;
    isAttached(): boolean;
    load(services: IChannelServices): Promise<void>;
    protected abstract loadCore(services: IChannelStorageService): Promise<void>;
    protected readonly logger: ITelemetryLoggerExt;
    protected newAckBasedPromise<T>(executor: (resolve: (value: T | PromiseLike<T>) => void, reject: (reason?: any) => void) => void): Promise<T>;
    protected onConnect(): void;
    protected abstract onDisconnect(): any;
    protected abstract processCore(message: ISequencedDocumentMessage, local: boolean, localOpMetadata: unknown): any;
    protected reSubmitCore(content: any, localOpMetadata: unknown): void;
    protected rollback(content: any, localOpMetadata: unknown): void;
    // (undocumented)
    protected runtime: IFluidDataStoreRuntime;
    protected abstract get serializer(): IFluidSerializer;
    protected submitLocalMessage(content: any, localOpMetadata?: unknown): void;
    abstract summarize(fullTree?: boolean, trackState?: boolean, telemetryContext?: ITelemetryContext): Promise<ISummaryTreeWithStats>;
}

// @public @sealed
export interface SharedObjectKind<out TSharedObject = unknown> extends ErasedType<readonly ["SharedObjectKind", TSharedObject]> {
    is(value: IFluidLoadable): value is IFluidLoadable & TSharedObject;
}

// (No @packageDocumentation comment for this package)

```
